package com.anuththara18.attentionassessment.preliminaryguidance;

import androidx.appcompat.app.AppCompatActivity;
import androidx.cardview.widget.CardView;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import com.anuththara18.attentionassessment.R;

public class AttentionMilestonesActivity extends AppCompatActivity {

    CardView card1, card2, card3, card4, card5, card6;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_attention_milestones);

        card1 = findViewById(R.id.card1);
        card2 = findViewById(R.id.card2);
        card3 = findViewById(R.id.card3);
        card4 = findViewById(R.id.card4);
        card5 = findViewById(R.id.card5);
        card6 = findViewById(R.id.card6);

        card1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#FF1100";
                PreliminaryGuidanceActivity.heading = "0 - 1 years";
                PreliminaryGuidanceActivity.subheading = "Fleeting Attention";
                PreliminaryGuidanceActivity.text = "Attention flits from one thing to another.\n\n" +
                        "Attention is involuntary and is caught by stimuli.\n\n" +
                        "E.g. attention shifts from one object / person to another and is easily distracted by a new event occurring e.g. a loud noise.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        card2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#017EE1";
                PreliminaryGuidanceActivity.heading = "1 - 2 years";
                PreliminaryGuidanceActivity.subheading = "Rigid Attention";
                PreliminaryGuidanceActivity.text = "Can attend to a concrete task of child’s own choice.\n\n" +
                        "Attention is involuntary.\n\n" +
                        "Ignores external stimuli in order to focus.\n\n" +
                        "E.g. may concentrate on blocks but will ignore adult intervention both verbal and visual.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        card3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#FFBF00";
                PreliminaryGuidanceActivity.heading = "2 - 3 years";
                PreliminaryGuidanceActivity.subheading = "Single Channelled Attention";
                PreliminaryGuidanceActivity.text = "Child still cannot attend to other stimuli while focussing on a activity.\n\n" +
                        "Can shift full attention with adult’s help to the adult.\n\n" +
                        "Control of the child’s attention lies with the adult.\n\n" +
                        "E.g. if a child is playing a game, the adult can shift the attention of the child, for example by saying “ look at this” the child will respond and then go back to their game.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        card4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#00BC08";
                PreliminaryGuidanceActivity.heading = "3 - 4 years";
                PreliminaryGuidanceActivity.subheading = "Focusing Attention";
                PreliminaryGuidanceActivity.text = "The child is starting to control their own focus.\n\n" +
                        "Child can still only focus on one activity at a time.\n\n" +
                        "Will give full attention to specific activity including both visual and auditory.\n\n" +
                        "Can focus and refocus their attention by themselves.\n\n" +
                        "E.g. child can be playing a game will stop when adult speaks, give their full attention to the adult, and then will continue with their game.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        card5.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#E91E63";
                PreliminaryGuidanceActivity.heading = "4 - 5 years";
                PreliminaryGuidanceActivity.subheading = "Two Channelled Attention";
                PreliminaryGuidanceActivity.text = "Child can focus on an activity but can also listen to what is being said without stopping their activity and looking at the speaker.\n\n" +
                        "Can focus on a single aspect of a complex situation.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        card6.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#FF5722";
                PreliminaryGuidanceActivity.heading = "5 - 6 years";
                PreliminaryGuidanceActivity.subheading = "Integrated attention";
                PreliminaryGuidanceActivity.text = "Two channel attention is well entrenched and the child can implement it across different situations and people.\n\n" +
                        "Attention is well established and sustained.\n\n" +
                        "Child can shut out unwanted and unrelated information and can concentrate only on the necessary features.";
                PreliminaryGuidanceActivity.image = R.drawable.red_angry_bird;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

    }
}