package com.anuththara18.attentionassessment.preliminaryguidance;

import androidx.appcompat.app.AppCompatActivity;
import androidx.cardview.widget.CardView;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import com.anuththara18.attentionassessment.R;

public class AttentionTypesActivity extends AppCompatActivity {

    CardView attention, focusedAttention, selectiveAttention, dividedAttention, sustainedAttention, alternatingAttention;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_attention_types);

        attention = findViewById(R.id.attention);
        focusedAttention = findViewById(R.id.focusedAttention);
        selectiveAttention = findViewById(R.id.selectiveAttention);
        dividedAttention = findViewById(R.id.dividedAttention);
        sustainedAttention = findViewById(R.id.sustainedAttention);
        alternatingAttention = findViewById(R.id.alternatingAttention);

        attention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#016E6D";
                PreliminaryGuidanceActivity.heading = "What is Attention?";
                PreliminaryGuidanceActivity.subheading = "";
                PreliminaryGuidanceActivity.text = "Attention refers to one’s ability to select and focus on relevant stimuli. " +
                        "\n\nIn other words, it’s how we actively process information in our environment and tune out information, perceptions and sensations that aren’t relevant at the moment.";
                PreliminaryGuidanceActivity.image = R.drawable.deficiency;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        focusedAttention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#FF1100";
                PreliminaryGuidanceActivity.heading = "Focused Attention";
                PreliminaryGuidanceActivity.subheading = "Focus on a specific event.";
                PreliminaryGuidanceActivity.text = "This type of attention involves being able to be suddenly drawn to a specific visual, auditory, or tactile stimuli such as a loud noise or a flash of light. " +
                        "\n\nIt is a way of responding rapidly to external stimuli, which can be particularly important in situations where something in the environment requires immediate attention and quick action.";
                PreliminaryGuidanceActivity.image = R.drawable.foc;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        selectiveAttention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#017EE1";
                PreliminaryGuidanceActivity.heading = "Selective Attention";
                PreliminaryGuidanceActivity.subheading = "Focus on one thing at a time.";
                PreliminaryGuidanceActivity.text = "Selective attention involves being able to choose and selectively attend to certain stimuli in the environment while at the same time tuning other things out. " +
                        "\n\nFor example, you might selectively attend to a book you are reading while tuning out the sound of your next-door neighbor's car alarm going off.\n" +
                        "\n" +
                        "This type of attention requires you to be able to tune out extraneous external stimuli, but also internal distractions such as thoughts and emotions in order to stay selectively attuned to a task.\n\n";
                PreliminaryGuidanceActivity.image = R.drawable.sel;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        dividedAttention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#FFBF00";
                PreliminaryGuidanceActivity.heading = "Divided Attention";
                PreliminaryGuidanceActivity.subheading = "Focus on two events at once.";
                PreliminaryGuidanceActivity.text = "Divided attention, is a form of attention that also involves multitasking. " +
                        "In this case, however, attention is divided between multiple tasks. " +
                        "\n\nRather than shifting focus, people attend to these stimuli at the same time and may respond simultaneously to multiple demands.";
                PreliminaryGuidanceActivity.image = R.drawable.div;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        sustainedAttention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#00BC08";
                PreliminaryGuidanceActivity.heading = "Sustained Attention";
                PreliminaryGuidanceActivity.subheading = "Focus for a long period of time.";
                PreliminaryGuidanceActivity.text = "This is the ability to focus on something for long periods of time without being distracted. " +
                        "\n\nIn other words, you concentrate on time-consuming tasks by using sustained attention. " +
                        "\n\nThere are three stages of sustained attention:\n" +
                        "\n" +
                        "Paying Attention, When You Start To Focus\n" +
                        "Keeping Attention, When You Continue To Focus\n" +
                        "Ending Attention, When You Finally Stop Paying Attention\n" +
                        "\n";
                PreliminaryGuidanceActivity.image = R.drawable.sus;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });

        alternatingAttention.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PreliminaryGuidanceActivity.color = "#E91E63";
                PreliminaryGuidanceActivity.heading = "Alternating Attention";
                PreliminaryGuidanceActivity.subheading = "Alternate back and forth between tasks";
                PreliminaryGuidanceActivity.text = "Alternating attention involves shifting your focus and switching between two or more tasks with different cognitive demands." +
                        "\n\nIt's not about focusing on more than one thing at the same time, but about stopping attending to one thing and then switching to the next task. ";
                PreliminaryGuidanceActivity.image = R.drawable.alt;
                startActivity(new Intent(getApplicationContext(), MilestonesDescriptionActivity.class));
            }
        });


    }
}