package com.anuththara18.attentionassessment.selective;

import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.graphics.pdf.PdfDocument;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.core.content.FileProvider;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.anuththara18.attentionassessment.BuildConfig;
import com.anuththara18.attentionassessment.MyJsonArrayRequest;
import com.anuththara18.attentionassessment.R;
import com.anuththara18.attentionassessment.age.AgeActivity;
import com.anuththara18.attentionassessment.age.PreSchool;
import com.anuththara18.attentionassessment.alternating.AlternatingAttentionGame1;
import com.anuththara18.attentionassessment.consentform.ParentsConsentDatabaseHelper;
import com.anuththara18.attentionassessment.details.ParentDetailsActivity;
import com.anuththara18.attentionassessment.gender.GenderActivity;
import com.anuththara18.attentionassessment.home.NavigationDrawerActivity;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.OnProgressListener;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.opencsv.CSVWriter;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static android.Manifest.permission.MANAGE_EXTERNAL_STORAGE;
import static android.Manifest.permission.READ_EXTERNAL_STORAGE;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class SelectiveACompleteScreen extends AppCompatActivity {

    ImageView complete;

    List<Selective> dataList;
    SQLiteDatabase mDatabase;

    // declaring width and height
    // for our PDF file.
    int pageHeight = 1520;
    int pagewidth = 792;

    // creating a bitmap variable
    // for storing our images
    Bitmap bmp, bmp2, scaledbmp, scaledbmp2;
    public static ParentsConsentDatabaseHelper sqLiteHelper;

    // constant code for runtime permissions
    private static final int PERMISSION_REQUEST_CODE = 200;

    RequestQueue queue;
    JsonArrayRequest jsonObjectRequest;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (Build.VERSION.SDK_INT < 16) {
            getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                    WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
        View decorView = getWindow().getDecorView();
        int uiOptions = View.SYSTEM_UI_FLAG_FULLSCREEN;
        decorView.setSystemUiVisibility(uiOptions);
        setContentView(R.layout.activity_complete_screen2);

        ///////////////////////////////////////////////////////////////////////////////////////

        float pcr = (SelectiveAttentionGame1.noOfCorrectResponses / SelectiveAttentionGame1.totalCorrectResponses) * 100;
        float oer = (SelectiveAttentionGame1.noOfOmmissionErrors / SelectiveAttentionGame1.totalCorrectResponses) * 100;
        float cer = (SelectiveAttentionGame1.noOfCommissionErrors / SelectiveAttentionGame1.totalCorrectResponses) * 100;

        // send data to api in the form of key value pairs
        Map<Object, Float> mapData = new HashMap<Object, Float>();
        String url = "https://attention-assessment.herokuapp.com/predict";
        queue = Volley.newRequestQueue(this);

        JSONArray jsonArray=new JSONArray();
        JSONObject jsonObj=new JSONObject();
        try {
            jsonObj.put("age", (float) 5);
            jsonObj.put("mrt", (float) SelectiveAttentionGame1.completionTime);
            jsonObj.put("pcr", (float) pcr);
            jsonObj.put("oer", (float) oer);
            jsonObj.put("cer", (float) cer);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        jsonArray.put(jsonObj);

        mapData.put("age", (float) 5);
        mapData.put("mrt", (float) SelectiveAttentionGame1.completionTime);
        mapData.put("pcr", (float) pcr);
        mapData.put("oer", (float) oer);
        mapData.put("cer", (float) cer);

        //(Request.Method.POST, url, new JSONObject(mapData), new Response.Listener<JSONArray>() {

        try {

            MyJsonArrayRequest request=new MyJsonArrayRequest(Request.Method.POST, url, new JSONObject(mapData), new Response.Listener<JSONArray>() {
                @Override
                public void onResponse(JSONArray response) {

                    Log.i("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaonResponse", ""+response.toString());
                }
            }, new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    error.printStackTrace();
                    Log.i("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaonErrorResponse", "Error");
                }
            });

            /*
            jsonObjectRequest = new JsonArrayRequest
                    (Request.Method.POST, url, new JSONArray(mapData), new Response.Listener<JSONArray>() {

                        @Override
                        public void onResponse(JSONArray response) {
                            String ans= null;
                            try {

                                // Loop through the array elements
                                for(int i=0;i<response.length();i++){
                                    // Get current json object
                                    JSONObject answer = response.getJSONObject(i);
                                    ans = answer.getString("ans"); //I'll take out the value whose key is ans

                                }
                                    Log.d("222222222222222222222222222222222222222222222", ans) ;

                            } catch (JSONException e) {
                                e.printStackTrace();
                            }
                            Toast.makeText(getApplicationContext(),ans,Toast.LENGTH_LONG).show();
                        }
                    }, new Response.ErrorListener() {

                        @Override
                        public void onErrorResponse(VolleyError error) {
                            // TODO: Handle error
                            Log.d("222222222222222222222222222222222222222222222", String.valueOf(error)) ;

                            Toast.makeText(getApplicationContext(),"Opps something went wrong",Toast.LENGTH_LONG).show();
                        }
                    });
            */

            //queue.add(jsonObjectRequest);
            queue.add(request);

        } catch (Exception e) {
            Log.d("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa", "String.valueOf(error)") ;

            e.printStackTrace();
        }

        ///////////////////////////////////////////////////////////////////////////////////////////

        sqLiteHelper = new ParentsConsentDatabaseHelper(this, "ParentsConsent.sqlite", null, 1);

        complete = findViewById(R.id.complete);

        complete.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(getApplicationContext(), NavigationDrawerActivity.class);
                finish();
                startActivity(intent);
            }
        });

        /*******************************************************************************************/

        try {
            Cursor cursor = sqLiteHelper.getData("SELECT * FROM ParentsConsent");

            while (cursor.moveToNext()) {
                byte[] image = cursor.getBlob(0);
                bmp2 = BitmapFactory.decodeByteArray(image, 0, image.length);
                //fingerprintImageView.setImageBitmap(bmp);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        // initializing our variables.
        bmp = BitmapFactory.decodeResource(getResources(), R.drawable.selective);
        scaledbmp = Bitmap.createScaledBitmap(bmp, 140, 140, false);
        //scaledbmp2 = Bitmap.createScaledBitmap(bmp2, 200, 200, false);
        scaledbmp2 = BITMAP_RESIZER(bmp2, 400, 400);

        // below code is used for
        // checking our permissions.
        if (checkPermission()) {
            //Toast.makeText(this, "Permission Granted", Toast.LENGTH_SHORT).show();
        } else {
            requestPermission();
        }

        /*******************************************************************************************/

        dataList = new ArrayList<>();

        //opening the database
        mDatabase = openOrCreateDatabase(SelectiveAttentionGame1.DATABASE_NAME, MODE_PRIVATE, null);

        /*******************************************************************************************/

        //this part will display the data in the list

        //we used rawQuery(sql, selectionargs) for fetching all the employees
        Cursor cursorEmployees = mDatabase.rawQuery("SELECT * FROM selectiveAttention", null);

        //if the cursor has some data
        if (cursorEmployees.moveToFirst()) {
            //looping through all the records
            do {
                //pushing each record in the employee list
                dataList.add(new Selective(
                        cursorEmployees.getInt(0),
                        cursorEmployees.getInt(1),
                        cursorEmployees.getString(2),
                        cursorEmployees.getString(3),
                        cursorEmployees.getString(4),
                        cursorEmployees.getString(5),
                        cursorEmployees.getString(6),
                        cursorEmployees.getInt(7),
                        cursorEmployees.getInt(8),
                        cursorEmployees.getInt(9),
                        cursorEmployees.getInt(10),
                        cursorEmployees.getInt(11),
                        cursorEmployees.getInt(12),
                        cursorEmployees.getString(13)
                ));
            } while (cursorEmployees.moveToNext());
        }
        //closing the cursor
        cursorEmployees.close();

        /*******************************************************************************************/

        String csv = (Environment.getExternalStorageDirectory().getAbsolutePath() + "/SelectiveAttention.csv"); // Here csv file name is MyCsvFile.csv

        // csv will create inside phone storage.
        CSVWriter writer = null;
        try {
            writer = new CSVWriter(new FileWriter(csv));

            String[] entries = {"id","child_gender","child_age","level",
                    "stimulus", "colour", "sequence_of_responses", "order_of_selection", "no_of_clicks",
                    "total_correct_responses","correct_responses",
                    "commission_errors","omission_errors","mean_reaction_time",
                    "total_duration","diagnosis"};
            writer.writeNext(entries);

            List<String[]> data = new ArrayList<String[]>();

            for (int i = 0; i < dataList.size(); i++) {

                Selective gameData = dataList.get(i);
                data.add(new String[]{ String.valueOf(gameData.getId()),
                        String.valueOf(String.valueOf(gameData.getChildID()).charAt(0)),
                        String.valueOf(String.valueOf(gameData.getChildID()).charAt(1)),
                        String.valueOf(String.valueOf(gameData.getChildID()).charAt(2)),
                        String.valueOf(gameData.getStimulus()),
                        String.valueOf(gameData.getColour()),
                        String.valueOf(gameData.getSequence_of_responses()),
                        String.valueOf(gameData.getOrder_of_selection()),
                        String.valueOf(gameData.getNo_of_clicks()),
                        String.valueOf(gameData.getTotalCorrectResponses()),
                        String.valueOf(gameData.getNoOfCorrectResponses()),
                        String.valueOf(gameData.getNoOfCommissionErrors()),
                        String.valueOf(gameData.getNoOfOmmissionErrors()),
                        String.valueOf(gameData.getMeanReactionTime()),
                        String.valueOf(gameData.getTotalDuration()),
                        String.valueOf(gameData.getDiagnosis())
                });
            }

            writer.writeAll(data); // data is adding to csv

            writer.close();
            //callRead();
        } catch (IOException e) {
            e.printStackTrace();
        }

        uploadToFirebase(csv);

        /*******************************************************************************************/

        PdfDocument pdfDocument = new PdfDocument();

        Paint paint = new Paint();
        Paint title = new Paint();

        PdfDocument.PageInfo mypageInfo = new PdfDocument.PageInfo.Builder(pagewidth, pageHeight, 1).create();

        PdfDocument.Page myPage = pdfDocument.startPage(mypageInfo);

        Canvas canvas = myPage.getCanvas();

        canvas.drawBitmap(scaledbmp, 56, 40, paint);
        canvas.drawBitmap(scaledbmp2, 400, 0, paint);

        title.setTypeface(Typeface.create(Typeface.DEFAULT, Typeface.BOLD));
        title.setTextSize(20);
        title.setColor(ContextCompat.getColor(this, R.color.orange));

        canvas.drawText("Selective Attention", 250, 80, title);

        title.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
        title.setColor(ContextCompat.getColor(this, R.color.black));
        title.setTextSize(15);

        canvas.drawText("Age : " + PreSchool.age, 150, 250, title);

        String gender;
        if (GenderActivity.gender == 2) {
            gender = "Male";
        }
        else {
            gender = "Female";
        }
        canvas.drawText("Gender: " + gender, 150, 300, title);
        canvas.drawText("Child Name: " + ParentDetailsActivity.child_name, 150, 350, title);
        canvas.drawText("Contact No: " + ParentDetailsActivity.parent_contact, 150, 450, title);
        canvas.drawText("Email: " + ParentDetailsActivity.parent_email, 150, 500, title);

        title.setTypeface(Typeface.defaultFromStyle(Typeface.NORMAL));
        title.setColor(ContextCompat.getColor(this, R.color.black));
        title.setTextSize(15);

        //title.setTextAlign(Paint.Align.CENTER);

        int space = 0;
        // Printing elements one by one
        for (int i = 0; i < dataList.size(); i++) {
            //getting employee of the specified position
            Selective data = dataList.get(i);

            Log.d("********************************", "ID : " + String.valueOf(data.getId()) + ", \t" +
                    "C: " + String.valueOf(data.getChildID()) + ", \t" +
                    "TCR: " + String.valueOf(data.getTotalCorrectResponses()) + ", \t" +
                    "CR: " + String.valueOf(data.getNoOfCorrectResponses()) + ", \t" +
                    "CE: " + String.valueOf(data.getNoOfCommissionErrors()) + ", \t" +
                    "OE: " + String.valueOf(data.getNoOfOmmissionErrors()) + ", \t" +
                    "MRT: " + String.valueOf(data.getMeanReactionTime()) + ", \t" +
                    "TD: " + String.valueOf(data.getTotalDuration()) );

            canvas.drawText("ID : " + String.valueOf(data.getId()) + ", \t" +
                    "C: " + String.valueOf(data.getChildID()) + ", \t" +
                    "TCR: " + String.valueOf(data.getTotalCorrectResponses()) + ", \t" +
                    "CR: " + String.valueOf(data.getNoOfCorrectResponses()) + ", \t" +
                    "CE: " + String.valueOf(data.getNoOfCommissionErrors()) + ", \t" +
                    "OE: " + String.valueOf(data.getNoOfOmmissionErrors()) + ", \t" +
                    "MRT: " + String.valueOf(data.getMeanReactionTime()) + ", \t" +
                    "TD: " + String.valueOf(data.getTotalDuration()) + " ", 150, 550 + space, title);

            space = space + 50;
        }

        pdfDocument.finishPage(myPage);

        File file = new File(Environment.getExternalStorageDirectory(), "SelectiveAttention.pdf");

        try {
            pdfDocument.writeTo(new FileOutputStream(file));
            //Toast.makeText(getApplicationContext(), "PDF file generated successfully.", Toast.LENGTH_LONG).show();

        } catch (IOException e) {
            e.printStackTrace();
        }
        pdfDocument.close();

    }


    /**************************************************************************************************/

    private boolean checkPermission() {
        // checking of permissions.
        int permission1 = ContextCompat.checkSelfPermission(getApplicationContext(), WRITE_EXTERNAL_STORAGE);
        int permission2 = ContextCompat.checkSelfPermission(getApplicationContext(), READ_EXTERNAL_STORAGE);
        int permission3 = ContextCompat.checkSelfPermission(getApplicationContext(), MANAGE_EXTERNAL_STORAGE);
        return permission1 == PackageManager.PERMISSION_GRANTED && permission2 == PackageManager.PERMISSION_GRANTED && permission3 == PackageManager.PERMISSION_GRANTED;
    }

    /*************************************************************************************************

    public void sendData(View view) {
        // send data to api in the form of key value pairs
        HashMap<String, Float> data = new HashMap<String, Float>();
        String url = "";
        queue = Volley.newRequestQueue(this);

        float pcr = (AlternatingAttentionGame1.no_of_correct_responses / AlternatingAttentionGame1.total_correct_responses) * 100;
        float oer = (AlternatingAttentionGame1.no_of_ommission_errors / AlternatingAttentionGame1.total_correct_responses) * 100;
        float cer = (AlternatingAttentionGame1.no_of_commission_errors / AlternatingAttentionGame1.total_correct_responses) * 100;
        data.put("meanReactionTime", (float) AlternatingAttentionGame1.mean_reaction_time);
        data.put("percentageOfCorrectResponses", (float) pcr);
        data.put("omissionErrorRate", (float) oer);
        data.put("commissionErrorRate", (float) cer);
        data.put("age", (float) 5);

        jsonObjectRequest = new JsonObjectRequest
                (Request.Method.POST, url, new JSONObject(data), new Response.Listener<JSONObject>() {

                    @Override
                    public void onResponse(JSONObject response) {
                        String ans= null;
                        try {
                            ans = response.getString("ans"); //I'll take out the value whose key is ans
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                        Toast.makeText(getApplicationContext(),ans,Toast.LENGTH_LONG).show();
                    }
                }, new Response.ErrorListener() {

                    @Override
                    public void onErrorResponse(VolleyError error) {
                        // TODO: Handle error
                        Toast.makeText(getApplicationContext(),"Opps something went wrong",Toast.LENGTH_LONG).show();
                    }
                });
        queue.add(jsonObjectRequest);
    }

    ************************************************************************************************/

    private void requestPermission() {
        // requesting permissions if not provided.
        ActivityCompat.requestPermissions(this, new String[]{WRITE_EXTERNAL_STORAGE, READ_EXTERNAL_STORAGE, MANAGE_EXTERNAL_STORAGE}, PERMISSION_REQUEST_CODE);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == PERMISSION_REQUEST_CODE) {
            if (grantResults.length > 0) {
                // after requesting permissions we are showing
                // users a toast message of permission granted.
                boolean writeStorage = grantResults[0] == PackageManager.PERMISSION_GRANTED;
                boolean readStorage = grantResults[1] == PackageManager.PERMISSION_GRANTED;

                if (writeStorage && readStorage) {
                    //Toast.makeText(this, "Permission Granted..", Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(this, "Permission Denied.", Toast.LENGTH_SHORT).show();
                    finish();
                }
            }
        }
    }

    /**************************************************************************************************/

    public Bitmap BITMAP_RESIZER(Bitmap bitmap,int newWidth,int newHeight) {
        Bitmap scaledBitmap = Bitmap.createBitmap(newWidth, newHeight, Bitmap.Config.ARGB_8888);

        float ratioX = newWidth / (float) bitmap.getWidth();
        float ratioY = newHeight / (float) bitmap.getHeight();
        float middleX = newWidth / 2.0f;
        float middleY = newHeight / 2.0f;

        Matrix scaleMatrix = new Matrix();
        scaleMatrix.setScale(ratioX, ratioY, middleX, middleY);

        Canvas canvas = new Canvas(scaledBitmap);
        canvas.setMatrix(scaleMatrix);
        canvas.drawBitmap(bitmap, middleX - bitmap.getWidth() / 2, middleY - bitmap.getHeight() / 2, new Paint(Paint.FILTER_BITMAP_FLAG));

        return scaledBitmap;

    }

    public void uploadToFirebase(String csv) {
        FirebaseAuth auth = FirebaseAuth.getInstance();
        if ( auth.getCurrentUser() == null ) {
            auth.signInAnonymously().addOnCompleteListener(this, new OnCompleteListener<AuthResult>() {
                @Override
                public void onComplete(@NonNull Task<AuthResult> task) {
                    Log.i("**********************************************test user", String.valueOf(task.isSuccessful()));
                    Log.i("**********************************************test user", String.valueOf(auth.getCurrentUser().getUid()));
                }
            });
        }
        else {

            StorageReference storageRef = FirebaseStorage.getInstance().getReference();

            Uri file = Uri.fromFile(new File(csv));

            //StorageReference storageReference = storageRef.child(auth.getCurrentUser().getUid() + "/Game1/" + file.getLastPathSegment());
            StorageReference storageReference = storageRef.child(auth.getCurrentUser().getUid() + "/SelectiveAttention/" + file.getLastPathSegment());
            storageReference.putFile(file).addOnProgressListener(new OnProgressListener<UploadTask.TaskSnapshot>() {
                @Override
                public void onProgress(@NonNull UploadTask.TaskSnapshot snapshot) {
                    //Toast.makeText(getApplicationContext(), "Upload Filed", Toast.LENGTH_SHORT).show();
                }
            }).addOnSuccessListener(new OnSuccessListener<UploadTask.TaskSnapshot>() {
                @Override
                public void onSuccess(UploadTask.TaskSnapshot taskSnapshot) {
                    //Toast.makeText(getApplicationContext(), "Upload successful", Toast.LENGTH_SHORT).show();
                }
            });
        }

    }
}
